/**
 * Licensed to Jasig under one or more contributor license
 * agreements. See the NOTICE file distributed with this work
 * for additional information regarding copyright ownership.
 * Jasig licenses this file to you under the Apache License,
 * Version 2.0 (the "License"); you may not use this file
 * except in compliance with the License. You may obtain a
 * copy of the License at:
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on
 * an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
 * KIND, either express or implied. See the License for the
 * specific language governing permissions and limitations
 * under the License.
 */

package org.openregistry.core.domain.sor;

import java.io.*;

/**
 * Internal representation of a System of Record.
 *
 * @version $Revision: 22842 $ $Date: 2011-01-21 11:14:09 -0500 (Fri, 21 Jan 2011) $
 * @since 0.1
 */
public interface SystemOfRecord extends Serializable {

    /**
     * The string representation of this SystemOfRecord.  CANNOT be NULL.  Can change over time.
     *
     * @return the string id (i.e. "registrar").
     */
    String getSorId();
}
